<?php
// ***************************************************************************
// *   adduser.php - uj felhasznalo hozzaadasa                               *
// *-------------------------------------------------------------------------*
// *   copyright  : (C) 2001 Erno Rigo                                       *
// *   email      :          mcree@freemail.hu                               *
// ***************************************************************************
//
// ***************************************************************************
// *                                                                         *
// *   This product includes PHP, freely available from http://www.php.net   *
// *                                                                         *
// *   This program is free software. Redistribution and use in source and   *
// *   binary forms, with or without modification is possible under the      *
// *   terms of the PHP License, version 2.02 published by the PHP Group.    *
// *                                                                         *
// *   This software consists of voluntary contributions made by many        *
// *   individuals on behalf of the PHP Group.                               *
// *                                                                         *
// ***************************************************************************
//
// DEVELOPMENT HISTORY:
//
// Tue Oct 30 14:19:31 2001
//	letrehoztam - Rigo Erno
//
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

    require_once("GLOBALS.php");
    require_once("readskin.php");
    require_once("postgres.php");

    function adduser() {
	global	$SITEPATH,			// Site eleresi utvonal pl. adduser-hez	
		$POST_ADDUSER_NAME,		// Form adatok... (ahol nem mas, ott string)
		$POST_ADDUSER_PASSWORD,		// ...
		$POST_ADDUSER_PASSWORD_RETYPE,	// ...
		$POST_ADDUSER_REALNAME,		// ...
		$POST_ADDUSER_COMPANY,		// ... 
		$POST_ADDUSER_CITY,		// ...
		$POST_ADDUSER_REMINDER,		// ...
		$POST_ADDUSER_REMIND,		// ...
		$POST_ADDUSER_NEWSLETTER;	// ... (boolean!)
		
	$db=connect(); // connect database
		
	if(!isset($POST_ADDUSER_NAME)) $POST_ADDUSER_NEWSLETTER="CHECKED";  //default on
	
	$body="skin_adduser.html";
	
	if(isset($POST_ADDUSER_NAME)) { // ha volt mar post...
	    if((strlen($POST_ADDUSER_NAME)>50) or (strlen($POST_ADDUSER_NAME)<3) or (!ereg("[-a-zA-Z_].",$POST_ADDUSER_NAME))) { // ellenorizzuk az usernevet szintaktikailag
		$error=readskin("","","skin_adduser_username_short.html");
	    } else if(strlen($POST_ADDUSER_PASSWORD)<3) { // tul rovid jelszo
		$error=readskin("","","skin_adduser_password_short.html");
	    } else if($POST_ADDUSER_PASSWORD!=$POST_ADDUSER_PASSWORD_RETYPE) { // nem egyezik a ket jelszo
		$error=readskin("","","skin_adduser_password_mismatch.html");
	    } else if((strlen($POST_ADDUSER_REALNAME)<3) or (strlen($POST_ADDUSER_COMPANY)<3) or (strlen($POST_ADDUSER_CITY)<3)) { // hianyzo kotelezo mezok
		$error=readskin("","","skin_adduser_nonoptional.html");
	    } else if (pg_numrows(pg_exec($db,"select name from users where name='$POST_ADDUSER_NAME'"))!=0) { // hmm szintaktikailag minden rendben van, mostmar csak az lehet, hogy van mar ilyen user
		$error=readskin("","","skin_adduser_user_exists.html");
	    } else { // a vegen lehet, hogy minden rendben van? na mind1 hozzaadjuk az uj usert... innentol lefele mar nem szabadna hibaba futni egy jol mukodo rendszer eseten
		if($POST_ADDUSER_NEWSLETTER=="CHECKED") {$newsletter="true";} else {$newsletter="false";};
		system("sudo /var/www/freemail/etc/bin/adduser.sh '$POST_ADDUSER_NAME' '$POST_ADDUSER_REALNAME' '$POST_ADDUSER_PASSWORD' >> /dev/null",$result);
		if($result) { // letre kell hozni a home konyvtarat
		    $error=readskin("","","skin_adduser_user_exists.html")."adduser"; // az adduser nem futott le sikeresen, ez vagy azt jelenti, nagy gaz van, vagy azt, hogy a felhasznalo mar letezik, mint unix rendszerfelhasznalo, mindenesetre a sima 'user exists' uzenetet adjuk vissza... FIXME: mi van, ha valami elbugzik, es azt hiszi a luzer, hogy mindig letezo nevet ad meg... ezen meg gondolkodni kell...		    
		} else if(!pg_exec($db,"insert into users (name,password,realname,company,city,newsletter,reminder,remind) 
				 values ('$POST_ADDUSER_NAME','$POST_ADDUSER_PASSWORD','$POST_ADDUSER_REALNAME','$POST_ADDUSER_COMPANY','$POST_ADDUSER_CITY','$newsletter','$POST_ADDUSER_REMINDER','$POST_ADDUSER_REMIND')")) { // beszurjuk sql adatbazisba is
		    $error=readskin("","","skin_adduser_db_insert_error.html");
		} else { // tenyleg minden rendben volt... a felhasznalo hozzaadva...
		    
		    $qry=pg_exec($db,"select id from users where name='$POST_ADDUSER_NAME'");
		    $res=pg_fetch_object($qry,0);
		    pg_exec($db,"insert into mailbox (userid,file,name,system)
				    values('$res->id','mbox','Postalda',true)");
		    pg_exec($db,"insert into mailbox (userid,file,name,system)
				    values('$res->id','piszk','Piszkozatok',true)");
		    pg_exec($db,"insert into mailbox (userid,file,name,system)
				    values('$res->id','sent','Elkldtt',true)");
		    pg_exec($db,"insert into mailbox (userid,file,name,system)
				    values('$res->id','trash','Szemetes',true)");
		
		    $body="skin_adduser_ok.html"; // errol ertesitjuk is a boldog felhasznalot
		    setcookie("COOKIE_USERNAME",$POST_ADDUSER_NAME,0); // kiteszunk egy cookie-t, hogy a fooldalon mar kapja is a nevet defaultbol
		};
	    }
	} else { // ez az elso megjelenitese az oldalnak, meg nem volt POST
	    $error=""; // ezert nincs hibauzenet sem
	};

	return readskin(array("|ADDUSER_REMIND|","|ADDUSER_REMINDER|","|ERROR|","|ADDUSER_NAME|","|ADDUSER_PASSWORD|","|ADDUSER_PASSWORD_RETYPE|","|ADDUSER_REALNAME|","|ADDUSER_COMPANY|","|ADDUSER_CITY|","|ADDUSER_NEWSLETTER|"),
			array($POST_ADDUSER_REMIND,$POST_ADDUSER_REMINDER,$error,$POST_ADDUSER_NAME,$POST_ADDUSER_PASSWORD,$POST_ADDUSER_PASSWORD_RETYPE,$POST_ADDUSER_REALNAME,$POST_ADDUSER_COMPANY,$POST_ADDUSER_CITY,$POST_ADDUSER_NEWSLETTER),
			$body);
    };

?>
