<?php
// ***************************************************************************
// *   contacts.php - cimjegyzek modul                                       *
// *-------------------------------------------------------------------------*
// *   copyright  : (C) 2001 Erno Rigo                                       *
// *   email      :          mcree@freemail.hu                               *
// ***************************************************************************
//
// ***************************************************************************
// *                                                                         *
// *   This product includes PHP, freely available from http://www.php.net   *
// *                                                                         *
// *   This program is free software. Redistribution and use in source and   *
// *   binary forms, with or without modification is possible under the      *
// *   terms of the PHP License, version 2.02 published by the PHP Group.    *
// *                                                                         *
// *   This software consists of voluntary contributions made by many        *
// *   individuals on behalf of the PHP Group.                               *
// *                                                                         *
// ***************************************************************************
//
// DEVELOPMENT HISTORY:
//
// Tue Nov 20 15:52:57 2001
//	letrehoztam - Rigo Erno
//
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

    require_once("postgres.php");

    function contactdialog() {
	global	$SESS_USERID,
		$SESS_CURRGROUP,
		$POST_CONT_GRPNAME,
		$POST_CONT_GRP_SHOW,
		$POST_CONT_ADDGRP,
		$POST_CONT_GRP_DELETE,
		$POST_CONT_MAILTO,
		$POST_CONT_MAILCC,
		$CONT_GRP_ALL,
		$SESS_MAIL,
		$CONT_GRP_LIST,
		$POST_CONT_DESTGRP,
		$CONT_LIST;
	
	$db=connect();

	if(isset($POST_CONT_GRP_SHOW)) $SESS_CURRGROUP=$POST_CONT_GRP_SHOW;
	if(!isset($SESS_CURRGROUP)) $SESS_CURRGROUP=-1;
	
	if(isset($POST_CONT_MAILTO) or isset($POST_CONT_MAILCC)) {
	    if (is_array($CONT_LIST)) foreach($CONT_LIST as $contact) {
		$qry=pg_exec($db,"select name,realname,email from contacts where userid='$SESS_USERID' and id='$contact' order by name");
		$res=pg_fetch_object($qry,0);
		$new=parsemail($res->email);
		$new->personal=$res->realname;
		if(isset($POST_CONT_MAILTO)) {
		    $SESS_MAIL->mailto[]=$new;
		} else if(isset($POST_CONT_MAILCC)) {
		    $SESS_MAIL->mailcc[]=$new;
		};
	    };
	    
	    if (isset($CONT_GRP_ALL)) {
		$qry=pg_exec($db,"select id,name,realname,email from contacts where userid='$SESS_USERID' order by name");
		$row=0;
		while($res=@pg_fetch_object($qry,$row++)) {
		    $new=parsemail($res->email);
		    $new->personal=$res->realname;
		    if(isset($POST_CONT_MAILTO)) {
			$SESS_MAIL->mailto[]=$new;
		    } else if(isset($POST_CONT_MAILCC)) {
			$SESS_MAIL->mailcc[]=$new;
		    };
		};
	    } else if (is_array($CONT_GRP_LIST)) { 
		//forech($CONT_GRP_LIST as $group) {
		$groups=implode(",",$CONT_GRP_LIST);
		$qry=pg_exec($db,"select c.id,c.name,c.realname as realname,c.email as email from contacts c,contacts_groups cg where cg.contactid=c.id and cg.groupid in ($groups) and userid='$SESS_USERID' order by name");
		$row=0;
		while($res=@pg_fetch_object($qry,$row++)) {
		    $new=parsemail($res->email);
		    $new->personal=$res->realname;
		    if(isset($POST_CONT_MAILTO)) {
			$SESS_MAIL->mailto[]=$new;
		    } else if(isset($POST_CONT_MAILCC)) {
			$SESS_MAIL->mailcc[]=$new;
		    };
		};
	    };
	    
    	    $onlod="onload=\"refreshparent()\"";
    
	};

	if($SESS_CURRGROUP>0) {
	    $qry=pg_exec($db,"select c.id,c.name,c.realname,c.email from contacts c,contacts_groups cg where cg.contactid=c.id and cg.groupid=$SESS_CURRGROUP and userid='$SESS_USERID' order by name");
	} else {
	    $qry=pg_exec($db,"select id,name,realname,email from contacts where userid='$SESS_USERID' order by name");
	};
	$row=0;
	while($res=@pg_fetch_object($qry,$row++)) {
	    $users.=readskin(	array("|NAME_ENC|","|REALNAME_ENC|","|EMAIL_ENC|","|NAME|","|REALNAME|","|EMAIL|","|CONT_ID|"),
				array(imap_binary($res->name),imap_binary($res->realname),imap_binary($res->email),$res->name,$res->realname,$res->email,$res->id),
				"skin_contacts_body.html");
	
	};

	$qry=pg_exec($db,"select id,name from groups where userid='$SESS_USERID' order by name");
	$row=0;
	while($res=@pg_fetch_object($qry,$row++)) {
	    $groups.=readskin(	array("|NAME|","|CONT_GRP_ID|"),
				array($res->name,$res->id),
				"skin_contacts_group_body.html");
	    $grpopts.=readskin(	array("|NAME|","|ID|"),
				array($res->name,$res->id),
				"skin_contacts_group_option.html");
	};
	
	$skin="skin_contactdialog.html";
	
	if($SESS_CURRGROUP>0) {
	    $qry=pg_exec($db,"select name from groups where id='$SESS_CURRGROUP'");
	    $res=pg_fetch_object($qry,0);
	    $group=$res->name;
	} else {
	    $group=readskin("","","skin_contact_group_allgroups.html");
	};

	return readskin(array("|ONLOD|","|GROUP|","|GROUPOPTS|","|GROUPS|","|USERS|","|NAME|","|REALNAME|","|EMAIL|","|MOD_ID|"),
			array($onlod,$group,$grpopts,$groups,$users,imap_base64($POST_SET_CONT_NAME),imap_base64($POST_SET_CONT_REALNAME),imap_base64($POST_SET_CONT_EMAIL),$POST_CONT_MODIFY),
			$skin);    
    };
    
    function contacts() {
	global	$SESS_USERID,
		$SESS_CURRGROUP,
		$POST_SET_CONT_NAME,
		$POST_SET_CONT_REALNAME,
		$POST_SET_CONT_EMAIL,
		$POST_CONT_NAME,
		$POST_CONT_REALNAME,
		$POST_CONT_EMAIL,
		$POST_CONT_DELETE,
		$POST_CONT_MODIFY,
		$POST_CONT_GRPNAME,
		$POST_CONT_GRP_SHOW,
		$POST_CONT_ADDGRP,
		$POST_CONT_GRP_DELETE,
		$POST_CONT_MAILTO,
		$POST_CONT_MAILCC,
		$CONT_GRP_ALL,
		$SESS_MAIL,
		$CONT_GRP_LIST,
		$POST_CONT_DESTGRP,
		$CONT_LIST;
	
	$db=connect();

	if(isset($POST_CONT_GRP_SHOW)) $SESS_CURRGROUP=$POST_CONT_GRP_SHOW;
	if(!isset($SESS_CURRGROUP)) $SESS_CURRGROUP=-1;
	
	if(isset($POST_CONT_MAILTO) or isset($POST_CONT_MAILCC)) {
	    if (is_array($CONT_LIST)) foreach($CONT_LIST as $contact) {
		$qry=pg_exec($db,"select name,realname,email from contacts where userid='$SESS_USERID' and id='$contact' order by name");
		$res=pg_fetch_object($qry,0);
		$new=parsemail($res->email);
		$new->personal=$res->realname;
		if(isset($POST_CONT_MAILTO)) {
		    $SESS_MAIL->mailto[]=$new;
		} else if(isset($POST_CONT_MAILCC)) {
		    $SESS_MAIL->mailcc[]=$new;
		};
	    };
	    
//	    CONT_GRP_ALL
//		} else {
//		    
//	        };
	    if (isset($CONT_GRP_ALL)) {
		$qry=pg_exec($db,"select id,name,realname,email from contacts where userid='$SESS_USERID' order by name");
		$row=0;
		while($res=@pg_fetch_object($qry,$row++)) {
		    $new=parsemail($res->email);
		    $new->personal=$res->realname;
		    if(isset($POST_CONT_MAILTO)) {
			$SESS_MAIL->mailto[]=$new;
		    } else if(isset($POST_CONT_MAILCC)) {
			$SESS_MAIL->mailcc[]=$new;
		    };
		};
	    } else if (is_array($CONT_GRP_LIST)) { 
		//forech($CONT_GRP_LIST as $group) {
		$groups=implode(",",$CONT_GRP_LIST);
		$qry=pg_exec($db,"select c.id,c.name,c.realname as realname,c.email as email from contacts c,contacts_groups cg where cg.contactid=c.id and cg.groupid in ($groups) and userid='$SESS_USERID' order by name");
		$row=0;
		while($res=@pg_fetch_object($qry,$row++)) {
		    $new=parsemail($res->email);
		    $new->personal=$res->realname;
		    if(isset($POST_CONT_MAILTO)) {
			$SESS_MAIL->mailto[]=$new;
		    } else if(isset($POST_CONT_MAILCC)) {
			$SESS_MAIL->mailcc[]=$new;
		    };
		};
	    };
	    
	    return "<html><head><meta http-equiv=refresh content='0; url=?SHOW_BODY=email'></head>Please wait...</html>";
	};


	if(isset($POST_CONT_GRP_DELETE) and isset($CONT_GRP_LIST)) {
	    //echo pprint($CONT_GRP_LIST);
	    $lst=implode(",",$CONT_GRP_LIST);
	    pg_exec($db,"delete from groups where id in ($lst)");
	    pg_exec($db,"delete from contacts_groups where groupid in ($lst)");
	};
	
	if(isset($POST_CONT_GRPNAME)) {
	    pg_exec($db,"insert into groups (name,userid) values ('$POST_CONT_GRPNAME',$SESS_USERID)");
	};

	if(isset($POST_CONT_DELETE) and isset($CONT_LIST)) {
	    $lst=implode(",",$CONT_LIST);
	    if ($SESS_CURRGROUP<0) { // ha az 'osszes' csoportban vagyunk, igazabol torlunk
		$qry=pg_exec($db,"delete from contacts where id in($lst)");
		$qry=pg_exec($db,"delete from contacts_groups where contactid in($lst)");	// a csoportokbol is kitoroljuk
	    } else {	// egyebkent csak a hivatkozast toroljuk
		$qry=pg_exec($db,"delete from contacts_groups where contactid in($lst) and groupid=$SESS_CURRGROUP");
	    };
	};

	if(isset($POST_CONT_ADDGRP) and ($POST_CONT_DESTGRP>0) and isset($CONT_LIST)) {
//	    $lst=implode(",",$POST_CONT_DESTGRP);
	    foreach($CONT_LIST as $contact) // hibat nyelek, mert a duplikaciok miatt lehet hiba
		$qry=@pg_exec($db,"insert into contacts_groups (contactid,groupid) values($contact,$POST_CONT_DESTGRP)");
	};
	
	if(isset($POST_CONT_NAME)) {
	    $qry=pg_exec($db,"insert into contacts (name,realname,email,userid) values ('$POST_CONT_NAME','$POST_CONT_REALNAME','$POST_CONT_EMAIL','$SESS_USERID')");
	    if(isset($POST_CONT_MODIFY)) { // ha modositas volt
		$qry=pg_exec($db,"delete from contacts where id in($POST_CONT_MODIFY)");
		$POST_CONT_MODIFY=NULL;
	    };
	};

	if($SESS_CURRGROUP>0) {
	    $qry=pg_exec($db,"select c.id,c.name,c.realname,c.email from contacts c,contacts_groups cg where cg.contactid=c.id and cg.groupid=$SESS_CURRGROUP and userid='$SESS_USERID' order by name");
	} else {
	    $qry=pg_exec($db,"select id,name,realname,email from contacts where userid='$SESS_USERID' order by name");
	};
	$row=0;
	while($res=@pg_fetch_object($qry,$row++)) {
	    $users.=readskin(	array("|NAME_ENC|","|REALNAME_ENC|","|EMAIL_ENC|","|NAME|","|REALNAME|","|EMAIL|","|CONT_ID|"),
				array(imap_binary($res->name),imap_binary($res->realname),imap_binary($res->email),$res->name,$res->realname,$res->email,$res->id),
				"skin_contacts_body.html");
	
	};

	$qry=pg_exec($db,"select id,name from groups where userid='$SESS_USERID' order by name");
	$row=0;
	while($res=@pg_fetch_object($qry,$row++)) {
	    $groups.=readskin(	array("|NAME|","|CONT_GRP_ID|"),
				array($res->name,$res->id),
				"skin_contacts_group_body.html");
	    $grpopts.=readskin(	array("|NAME|","|ID|"),
				array($res->name,$res->id),
				"skin_contacts_group_option.html");
	};
	
	if(isset($POST_CONT_MODIFY)) {
	    $skin="skin_contacts_modify.html";
	} else {
	    $skin="skin_contacts.html";
	};
	
	if($SESS_CURRGROUP>0) {
	    $qry=pg_exec($db,"select name from groups where id='$SESS_CURRGROUP'");
	    $res=pg_fetch_object($qry,0);
	    $group=$res->name;
	} else {
	    $group=readskin("","","skin_contact_group_allgroups.html");
	};

	return readskin(array("|GROUP|","|GROUPOPTS|","|GROUPS|","|USERS|","|NAME|","|REALNAME|","|EMAIL|","|MOD_ID|"),
			array($group,$grpopts,$groups,$users,imap_base64($POST_SET_CONT_NAME),imap_base64($POST_SET_CONT_REALNAME),imap_base64($POST_SET_CONT_EMAIL),$POST_CONT_MODIFY),
			$skin);
    };

?>
