<?php
// ***************************************************************************
// *   email.php - html e-mail kuldo fuggveny                                *
// *-------------------------------------------------------------------------*
// *   copyright  : (C) 2001 by Erno Rigo                                    *
// *   email      : 		mcree@freemail.hu                            *
// ***************************************************************************
//
// ***************************************************************************
// *                                                                         *
// *   This product includes PHP, freely available from http://www.php.net   *
// *                                                                         *
// *   This program is free software. Redistribution and use in source and   *
// *   binary forms, with or without modification is possible under the      *
// *   terms of the PHP License, version 2.02 published by the PHP Group.    *
// *                                                                         *
// *   This software consists of voluntary contributions made by many        *
// *   individuals on behalf of the PHP Group.                               *
// *                                                                         *
// ***************************************************************************
//
// DEVELOPMENT HISTORY:
//
// Tue Sep 11 12:53:12 2001
//	letrehoztam - Rigo Erno
//
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

    require_once("GLOBALS.php");
    
    function email() {
	global	$POST_MAILTO,
		$POST_MAILCC,
		$POST_MAILSUBJ,
		$POST_MAILURGENT,
		$POST_MAILRESPREQ,
		$POST_MAILSENTSAVE,
		$POST_MAILBODY,
		$POST_MAIL_HTMLVIEW,
		$POST_MAILSIGN,
		$POST_MAILPOST,
		$POST_MAILSAVE,
		$POST_MAILTO_DEL,
		$POST_MAILCC_DEL,
		$POST_MAIL_SEL,
		$SESS_USERNAME,
		$SESS_USERID,
		$POST_FILE,
		$POST_FILE_size,
		$POST_FILE_type,
		$POST_FILE_name,
		$POST_MAILATTACH_DEL,
		$POST_ATTACH_SEL,
		$SESS_MAIL;

	//echo pprint(get_defined_vars());
	
	$db=connect();

	if(ereg(".*@.*",$POST_MAILTO)) $SESS_MAIL->mailto[]=parsemail($POST_MAILTO);
	if(ereg(".*@.*",$POST_MAILCC)) $SESS_MAIL->mailcc[]=parsemail($POST_MAILCC);
	if(isset($POST_MAILSUBJ)) $SESS_MAIL->mailsubj=$POST_MAILSUBJ;
	if(isset($POST_MAILBODY)) $SESS_MAIL->mailbody=$POST_MAILBODY;
	
	if(isset($POST_FILE) and ($POST_FILE_size>0)) {
	    $fp=fopen("$POST_FILE","r");
	    $contents=fread($fp,filesize("$POST_FILE"));
	    fclose($fp);
	    $new->type=$POST_FILE_type;
	    $new->name=$POST_FILE_name;
	    $new->size=$POST_FILE_size;
	    $new->contents=$contents;
	    $SESS_MAIL->attach[]=$new;
	};
	
	if(isset($POST_MAILTO_DEL) and is_array($POST_MAIL_SEL))
	    foreach($POST_MAIL_SEL as $todel) {
		unset($SESS_MAIL->mailto[$todel]);
	    };
	
	if(isset($POST_MAILCC_DEL) and is_array($POST_MAIL_SEL))
	    foreach($POST_MAIL_SEL as $todel) {
		unset($SESS_MAIL->mailcc[$todel]);
	    };
	
	if(isset($POST_MAILATTACH_DEL) and is_array($POST_ATTACH_SEL))
	    foreach($POST_ATTACH_SEL as $todel) {
		unset($SESS_MAIL->attach[$todel]);
	    };
	
	if(is_array($SESS_MAIL->mailto)) 
	    foreach($SESS_MAIL->mailto as $id => $to) {
		$mailto.=readskin(array("|EMAIL|","|ID|"),array(mailaddr($to),$id),"skin_email_mailaddrbody.html");
	    };
	if($mailto!="") {
	    $mailto=readskin(array("|MAILTO|"),array($mailto),"skin_email_mailaddr.html");
	};
	
	if(is_array($SESS_MAIL->mailcc)) 
	    foreach($SESS_MAIL->mailcc as $id => $cc) {
		$mailcc.=readskin(array("|EMAIL|","|ID|"),array(mailaddr($cc),$id),"skin_email_mailccaddrbody.html");
	    };
	if($mailcc!="") {
	    $mailcc=readskin(array("|MAILCC|"),array($mailcc),"skin_email_mailccaddr.html");
	};
	
	    
	if(is_array($SESS_MAIL->attach)) 
	    foreach($SESS_MAIL->attach as $id => $attach) {
		$mailattach.=readskin(	array("|NAME|","|TYPE|","|SIZE|","|ID|"),
					array($attach->name,$attach->type,byte2str($attach->size),$id),
					"skin_email_attachbody.html");
	    
	    };
	if($mailattach!="") {
	    $mailattach=readskin(array("|MAILATTACH|"),array($mailattach),"skin_email_attach.html");
	};
	    
	    
	if(isset($POST_MAILPOST) or isset($POST_MAILSAVE)) { // el kell kuldeni vagy menteni....

	    $qry=pg_exec($db,"select id,body from signs where userid='$SESS_USERID' and id='$POST_MAILSIGN'");
	    $row=0;
	    $res=@pg_fetch_object($qry,0);
	    $SESS_MAIL->mailbody.="\n$res->body";
	
	    $elso=true;
	    if(is_array($SESS_MAIL->mailto)) foreach($SESS_MAIL->mailto as $mail) {
		if($elso) {
		    $elso=false;
		    $mail_to="$mail->mailbox@$mail->host";
		} else {
		    $mail_bcc[]="$mail->mailbox@$mail->host";
		};
	    };
	
	    if(is_array($SESS_MAIL->mailcc)) foreach($SESS_MAIL->mailcc as $mail) {
		$mail_cc[]="$mail->mailbox@$mail->host";
	    };
	
	    $boundary="--=_MCREE_".rand(100000000,999999999)."_".rand(100000000,999999999)."_".rand(100000000,999999999)."_".rand(100000,999999);
	    $boundary2="--=_MCREE_".rand(100000000,999999999)."_".rand(100000000,999999999)."_".rand(100000000,999999999)."_".rand(100000,999999);
	
	    // elso mail sor!
	    $mail="";
	    $mail.="From: $SESS_USERNAME@freemail.tricon.hu\n";
	    $mail.="To: $mail_to\n";
	    $mail.="Subject: $SESS_MAIL->mailsubj\n";
	    if(isset($mail_cc)) 
		$mail.="CC: ".implode(",",$mail_cc)."\n";
	    if(isset($mail_bcc)) 
		$mail.="BCC: ".implode(",",$mail_bcc)."\n";
	    $mail.="X-Sender: $SESS_USERNAME@freemail.tricon.hu\n";
	    $mail.="X-Mailer: Freemail rendszer by McRee (c) 2001\n";
	    
            if(isset($POST_MAILRESPREQ)) {
		$mail.="Disposition-Notification-To: $SESS_USERNAME@freemail.tricon.hu\n";
		$mail.="Read-Receipt: $SESS_USERNAME@freemail.tricon.hu\n";
	        $mail.="X-Confirm-Reading-To: $SESS_USERNAME@freemail.tricon.hu\n";
		$mail.="Return-Receipt-To: $SESS_USERNAME@freemail.tricon.hu\n";
	    };
	    if(isset($POST_MAILURGENT)) {
		$mail.="X-Priority: 1\n";
	        $mail.="X-MSMail-Priority: High\n";
	    };

	    $mail.="Return-Path: $SESS_USERNAME@freemail.tricon.hu\n";
	    $mail.="Content-Type: multipart/mixed; boundary=\"$boundary\"\n";
	    $mail.="Mime-Version: 1.0\n";
	    $mail.="Content-Transfer-Encoding: 7bit\n\n";
	    $mail.="This is a multipart/MIXED mime message\n";
	    $mail.="\n--$boundary\n";
	    $mail.="Content-Type: multipart/alternative; boundary=\"$boundary2\"\n";
	    $mail.="Content-Transfer-Encoding: 7bit\n\n";
	    $mail.="This is a multipart/ALTERNATIVE mime message\n";
	    $mail.="\n--$boundary2\n";
	    $mail.="Content-Type: TEXT/PLAIN; charset=ISO-8859-2\n";
	    $mail.="Content-Transfer-Encoding: BASE64\n\n";
	    $mail.=imap_binary(strip_tags($SESS_MAIL->mailbody));
	    $mail.="\n\n--$boundary2\n";
	    $mail.="Content-Type: TEXT/HTML; charset=ISO-8859-2\n";
	    $mail.="Content-Transfer-Encoding: BASE64\n\n";
	    $mail.=imap_binary(nl2br($SESS_MAIL->mailbody));
	    $mail.="\n\n--$boundary2--\n";

    	    if(is_array($SESS_MAIL->attach)) 
		foreach($SESS_MAIL->attach as $id => $attach) {
	    
		    $mail.="\n\n--$boundary\n";
		    $mail.="Content-Type: ".$attach->type."; name=\"".$attach->name."\"\n";
		    $mail.="Content-Transfer-Encoding: base64\n";
		    $mail.="Content-Disposition: attachment; filename=\"".$attach->name."\"\n\n";
		    $mail.=imap_binary($attach->contents);
		};
	    
	    $mail.="\n\n--$boundary--\n";
	
//	    echo nl2br($mail);
	    
	    $SESS_MAIL=NULL;

	    if(isset($POST_MAILPOST)) {
//		mail($mail_to,$SESS_MAIL->mailsubj,"",$mail);
		$mailer = popen ("/usr/sbin/sendmail -t -i","w"); 
		fwrite ($mailer,$mail); 
		pclose ($mailer);  
	    };
	    if(isset($POST_MAILSENTSAVE)) {
		$mbox=openmbox();
		imap_append($mbox,"{localhost}sent",$mail);
		mboxstat("sent",true); // frissitjuk a cache-t a celra
//		echo pprint(imap_errors());
//		echo pprint(imap_alerts());
	    };
	    if(isset($POST_MAILSAVE)) {
		$mbox=openmbox();
		imap_append($mbox,"{localhost}piszk",$mail);
		mboxstat("piszk",true); // frissitjuk a cache-t a celra
//		echo pprint(imap_errors());
//		echo pprint(imap_alerts());
		return readskin("","","skin_email_saved.html");
	    };
    
	    return readskin("","","skin_email_sent.html");
	
	} else {

	    $qry=pg_exec($db,"select id,name from signs where userid='$SESS_USERID' order by name");
	    $row=0;
	    while($res=@pg_fetch_object($qry,$row++)) {
		$sigs.=readskin(array("|SIGN_ID|","|SIGN_NAME|"),array($res->id,$res->name),"skin_email_signatures.html");
	    }	

	    return readskin(array("|SIGNS|","|MAILATTACH|","|MAILTO|","|MAILCC|","|MAILSUBJ|","|MAILBODY|"),
			    array($sigs,$mailattach,$mailto,$mailcc,$SESS_MAIL->mailsubj,$SESS_MAIL->mailbody),
			    "skin_email.html");
	};
    };

?>
