<?php
// ***************************************************************************
// *   main.php - ez fogja ossze az oldalakat                                *
// *-------------------------------------------------------------------------*
// *   copyright  : (C) 2001 Erno Rigo                                       *
// *   email      :          mcree@freemail.hu                               *
// ***************************************************************************
//
// ***************************************************************************
// *                                                                         *
// *   This product includes PHP, freely available from http://www.php.net   *
// *                                                                         *
// *   This program is free software. Redistribution and use in source and   *
// *   binary forms, with or without modification is possible under the      *
// *   terms of the PHP License, version 2.02 published by the PHP Group.    *
// *                                                                         *
// *   This software consists of voluntary contributions made by many        *
// *   individuals on behalf of the PHP Group.                               *
// *                                                                         *
// ***************************************************************************
//
// DEVELOPMENT HISTORY:
//
// Tue Oct 30 13:56:03 2001
//	letrehoztam - Rigo Erno
//
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

    require_once("session.php");
    require_once("readskin.php");
    readskin("","","SKIN_INFO.php"); // ez csak azert kell, mert a $SESS_SKINPATH-ot ez allitja be
    require_once("$SESS_SKINPATH/SKIN_INFO.php"); // locale beallitasok inicializalasa
    require_once("adduser.php");
    require_once("login.php");
    require_once("mailbox.php");
    require_once("readmsg.php");
    require_once("menu.php");
    require_once("contacts.php");
    require_once("reminder.php");
    require_once("email.php");
    require_once("folders.php");
    require_once("options.php");

    function main() {
	global 	$SHOW_BODY,		// POST: melyik body-t kell megjeleniteni
		$SESS_SHOWBODY;		// melyik body-t kell megjeleniteni
	
	sess();
	
	if(isset($SHOW_BODY)) $SESS_SHOWBODY=$SHOW_BODY; // ha kaptunk uj showbody-t atallunk arra
		
	$defa=false;
	switch($SESS_SHOWBODY) {
	    case "adduser":	$body=adduser(); 	$ext=true; 	break;
	    case "reminder":	$body=reminder(); 	$ext=true; 	break;
	    case "mailbox":	$body=mailbox(); 			break;
	    case "readmsg":	$body=readmsg(); 			break;
	    case "email":	$body=email(); 				break;
	    case "chooseskin":	$body=chooseskin(); 			break;
	    case "contacts":	$body=contacts();			break;
	    case "folders":	$body=folders(); 			break;
	    case "options":	$body=options(); 			break;
	    case "contactdialog": $body=contactdialog(); $ext=true; 	break;
	    default:
		$body=login();
		$ext=true;
	};
	
	if(!$ext) $body=menu($body);
	
	echo readskin(array("|BODY|"),array($body),"skin_main.html");
    
    }

    function pprint($object,$depth='') {
	if((gettype($object)!='object') and (gettype($object)!='array')) {
	    return "<B>".gettype($object).":</B> ".htmlentities($object)."<br>\n";
	};
	while (list ($header, $value) = each ($object)) {
	    if((gettype($value)=='object') or (gettype($value)=='array')) {
    		$res.=$depth."<B>$header:</B> ".htmlentities($value)."\n";
		$res.="[<BR>".pprint($value,$depth.'&nbsp;&nbsp;&nbsp;').$depth."]<BR>";
//		$res.="reqrzio!";
	    } else {
    		$res.=$depth."<B>$header:</B> ".htmlentities($value)."<br>\n";
	    };
	};
	return $res;
    };

    main();

//    echo pprint(get_defined_vars());

//    $headers = get_defined_vars();
//      while (list ($header, $value) = each ($headers)) {
//        echo "$header: $value<br>\n";
//    };

?>
